/*
Gem Slider [Alpha 0.4]
Michael Vendittelli 
Copyright 2003

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include"level.h"

Level OpenExit(Level theLevel)
{
 int i,j;
 
 for( i = 0; i < LENGTH_MAX; i++)		//This function runs through the entire array looking for an exit.
 {
  for( j = 0; j < HEIGHT_MAX; j++)
  {
   if(theLevel.Stage[i][j][0] == 'X')
   {	
    theLevel.Stage[i][j][0] = 'Y';	//If it has been found, change it to 'Y'...an open exit.
   }
   else if(theLevel.Stage[i][j][1] == 'X')  //We have to check everything...the exit may be below something at the moment.
   {
    theLevel.Stage[i][j][1] = 'Y';	
   }
  }
 }
 return theLevel;
}

Level Create(char* FileName)
{
 // Okay, this creates the level.  One important thing to note is that there are no variables passed in by reference
 // throughout all the code.  This may change in the future (unlikely, given c's bad reaction to it), but for the moment...
 // nearly every function manipulates the level in some way.  It then returns the manipulated level.  Therefore, many
 // times you will see the assignment of a new level to theLevel...which gets passed around madly.  Pay close attention.	
	
 int i;
 
 Level theLevel; 
 theLevel.Moves = 0;
 theLevel.InMotion = 0;		//Obviously, it isn't moving and we don't have any gems yet.
 theLevel.NumberOfGems = 0;
 
 FILE* NewLevel = fopen(FileName,"r");		//This opens a File so we can read it in line by line.  
 						// The filename is given to us by the Menu System.

 if (!NewLevel)
 {
  NewLevel = fopen("Levels\\testtest.tst","r");	//If we can't find the file specified, just open this one.
 }

 char nextLine[60];

 fgets(nextLine,60,NewLevel);
 
 theLevel.ID = atoi(nextLine);
 
 fgets(nextLine,60,NewLevel);
 
 for(i = 0; i < 50; i++)
 {
   theLevel.name[i] = nextLine[i];	//First we store the name...character by character. 
 }					
 
 int l = strlen(theLevel.name); 	// Kill that pesky \n from screwing up print functions later.
 theLevel.name[l-1]='\0';  
  
 int LineCounter = 0;		//This will make sure we only count 24 lines into the Stage array.  So if there is any
 char nextLevelLine[30];	// more level data, it gets ignored.
 
 while (fgets(nextLevelLine,30,NewLevel)!=NULL && LineCounter < HEIGHT_MAX)
 { 
  for(i = 0; i < LENGTH_MAX; i++)
  {
   if(nextLevelLine[i] == 'G')
   {
    theLevel.NumberOfGems++;  //If we find a Gem while sifting through level data, increment this value.
   }
   theLevel.Stage[LineCounter][i][0] = nextLevelLine[i];  //Otherwise store the value in this position of the array.
   theLevel.Stage[LineCounter][i][1] = '0';	//We read it in, character by character; line by line.
  }						// The second layer has nothing...because nothing is pushed down.  This
  LineCounter++;				// could easily change at a later date.
 }

 fclose(NewLevel);
 return theLevel;
}
