#include<allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>

#include "error.h"
#include "level.h"
#include "editor.h"

void init() 
{
 allegro_init();			
 install_timer();		
 install_keyboard();	
}

void shutdown() 
{
 allegro_exit();
}

Cursor PlaceCursor(Cursor theCursor)
{
 if(theCursor.PosX < 1) theCursor.PosX = 1;
 if(theCursor.PosY < 1) theCursor.PosY = 1;
 if(theCursor.PosX > LENGTH_MAX) theCursor.PosX = 24;
 if(theCursor.PosY > HEIGHT_MAX) theCursor.PosY = 24;	
 gotoxy(theCursor.PosX,theCursor.PosY);
 
 return theCursor;
}

char Check(char Unit)
{
 if( Unit == '0') return ' ';	
 else if( Unit == '1') return 219;
 else if( Unit == 'S') return 2;
 else if( Unit == 'H') return 176;
 else if( Unit == 'E') return 157;
 else if( Unit == 'G') return 4;
 else if( Unit == 'T') return 15;
 else if( Unit == 'B') return 12;
 else if( Unit == 'X') return 'X';
 else if( Unit == 'Y') return 240;
 else return 178;
}

void Print(Level theLevel)
{
 int i, j;
 clrscr();	
 for ( i = 0; i < 24;  i++ )
   {		//i represents column, j represents row.  It will go through every position and run a Check.
      for ( j = 0; j < 24; j++ )
        {        
         printf("%c", Check(theLevel.Stage[i][j][0])); 
        }
        printf("\n");		//Since the name has a \n...in order to avoid an extra space, we do one or the other.
   }
 if(theLevel.InMotion == 1)
 {
  gotoxy(27, 1);  printf("1) Pid\n");
  gotoxy(27, 2);  printf("2) Fury\n");   
  gotoxy(27, 3);  printf("3) Koorik");
  gotoxy(27, 4);  printf("4) Trap");
  gotoxy(27, 5);  printf("5) Ice");
  gotoxy(27, 6);  printf("6) Wall");
  gotoxy(27, 7);  printf("7) Crystal");
  gotoxy(27, 8);  printf("8) Hole");
  gotoxy(27, 9); printf("9) Exit");
  gotoxy(27, 12); printf("Type a number above to create that character.");
  gotoxy(27, 14); printf("Name: %s", theLevel.name);
  gotoxy(27, 15); printf("#Gems: %d", theLevel.NumberOfGems);
  gotoxy(27, 16); printf("ID: %d", theLevel.ID);
 }
 else
 {
  gotoxy(27, 1);  printf("(N)ame Level\n");
  gotoxy(27, 2);  printf("(S)ave Level\n");   	
  gotoxy(27, 3);  printf("(L)oad Level");
  gotoxy(27, 4);  printf("(C)olour Scheme");
  gotoxy(27, 5);  printf("(E)dit Level");
  gotoxy(27, 6);  printf("(X)it Editor");

  gotoxy(27, 12); printf("Select an Option.");
  	
  gotoxy(27, 14); printf("Name: %s", theLevel.name);
  gotoxy(27, 15); printf("#Gems: %d", theLevel.NumberOfGems);
  gotoxy(27, 16); printf("ID: %d", theLevel.ID); 	
 }
 gotoxy(81,26);
}

int Scan(Level theLevel, int Type)
{
 int i, j;
 
 if(Type == 1)
 {
  for( i = 0; i < 24;  i++ )
  {
      for( j = 0; j < 24; j++ )
        if(theLevel.Stage[i][j][0] == 'S') return 0;
  }
 }	
 if(Type == 7)
   if(theLevel.NumberOfGems >= 5) return 0;
	
 return 1;
}

Level Place(Level theLevel, Cursor theCursor)
{
 char Placer = 'H';
 
 if(Scan(theLevel, theCursor.Type))
 {
  if(theCursor.Type == 1)   
  if(theCursor.Type == 2) Placer = 'E';
  if(theCursor.Type == 3) Placer = 'B';
  if(theCursor.Type == 4) Placer = 'T';
  if(theCursor.Type == 5) Placer = '0';
  if(theCursor.Type == 6) Placer = '1';
  if(theCursor.Type == 7) Placer = 'G';
  if(theCursor.Type == 8) Placer = 'H';
  if(theCursor.Type == 9) Placer = 'X';
  
  if(Placer == 'G') theLevel.NumberOfGems++;
  if(theLevel.Stage[theCursor.PosY-1][theCursor.PosX-1][0] == 'G') theLevel.NumberOfGems--;
  
  theLevel.Stage[theCursor.PosY-1][theCursor.PosX-1][0] = Placer;
 }
 return theLevel;
}

Level Edit(Level theLevel)
{
 Cursor theCursor;
 
 theCursor.PosX = 0;
 theCursor.PosY = 0;
 theLevel.InMotion = 0;
 
 theLevel.InMotion = 1;
 Print(theLevel);	
 
 int End = 0; 
 while( End != 1)
 {
  theCursor = PlaceCursor(theCursor);
  if(keypressed())
  {
   if (key[KEY_LEFT]) 
    theCursor.PosX--;
   else if (key[KEY_RIGHT])
    theCursor.PosX++;   
   else if (key[KEY_UP])
    theCursor.PosY--;
   else if (key[KEY_DOWN])
    theCursor.PosY++;
   else if (key[KEY_ESC]) 
    End = 1;
   else if (key[KEY_1])
    theCursor.Type = 1;
   else if (key[KEY_2]) 
    theCursor.Type = 2;
   else if (key[KEY_3])
    theCursor.Type = 3;
   else if (key[KEY_4])
    theCursor.Type = 4;
   else if (key[KEY_5])
    theCursor.Type = 5;
   else if (key[KEY_6])
    theCursor.Type = 6;
   else if (key[KEY_7])
    theCursor.Type = 7;
   else if (key[KEY_8])
    theCursor.Type = 8;
   else if (key[KEY_9])
    theCursor.Type = 9;
   else if (key[KEY_0])
    theCursor.Type = 0;
   else if (key[KEY_ENTER] || key[KEY_SPACE])
   {
    theLevel = Place(theLevel, theCursor);
    Print(theLevel);
   }	
   
   clear_keybuf();
  }
 }
 theLevel.InMotion = 0;
 return theLevel;
}

Level NameLevel(Level theLevel)
{
 int i;
 char Name[25];
 theLevel.NumberOfGems = 0;
 clear_keybuf();
 
 gotoxy(27, 14); printf("                                      ");
 gotoxy(27, 15); printf("                                      ");
 gotoxy(27, 16); printf("                                      ");
 gotoxy(27, 14); printf("Name: %s", theLevel.name);
 gotoxy(27, 15); printf("Change to: ");

 for(i = 0; i < 30; i++)
 {
  theLevel.name[i] = ' ';	
 }
 
 for(i = 0; i < 25; i++)
 {	
  Name[i] = readkey() & 0xff;
  if(Name[i] < 32)
    i = 51;
  else
  {
   theLevel.name[i] = Name[i];
   gotoxy(38+i, 15); 
   printf("%c", theLevel.name[i]);
   printf("\n");
   gotoxy(38+i+1, 15); 
  }
 }
 theLevel.name[i] = '\0';
 
 clrscr();
 return theLevel;
}

void Menu()
{
 Level theLevel = Create("testtest.tst");
 theLevel.InMotion = 0;
 Print(theLevel);
 
 int End = 0; 
 while( End != 1)
 {
  if(keypressed())
  {
   if (key[KEY_N]) 
   {
    theLevel = NameLevel(theLevel);
    Print(theLevel);
   }
   else if (key[KEY_S])
   {
    
   }
   else if (key[KEY_L])
   {
    
   }
   else if (key[KEY_C])
   {
    
   }
   else if (key[KEY_E]) 
   {
    theLevel = Edit(theLevel); 
    Print(theLevel);
   }
   else if (key[KEY_X] || key[KEY_ESC])
   {
    End = 1;	
   }
   clear_keybuf();
  }
 }
}

int main (int argc, char *argv[])
{
 init();	
 clrscr();
 Menu();
 clrscr();
 shutdown();
 return 0;			
}
END_OF_MAIN()
