#include<allegro.h>
#include <stdio.h>
#include <stdlib.h>

#include "error.h"
#include "level.h"
#include "paint.h"
#include "rules.h"
#include "lvllist.h"
#include "save.h"
#include "game.h"
#include "colour.h"

void init() 
{
 allegro_init();			
 install_timer();		
 install_keyboard();		
 initialise_joystick();
 install_mouse();
}

void shutdown() 
{
 allegro_exit();
}

int Setup(Level theLevel)
{
 Level MainLevel; 
 MainLevel = theLevel;
 PrintLevel(MainLevel);	
 set_keyboard_rate(0, 0); 


 int End = 0; 
 while( End != 1)
 {
  if(keypressed())
  {
   if (key[KEY_LEFT]) 
   {
    MainLevel = MoveLeft(MainLevel);
    MainLevel.Moves++;
   }
   else if (key[KEY_RIGHT])
   {
    MainLevel = MoveRight(MainLevel);
    MainLevel.Moves++;
   }
   else if (key[KEY_UP])
   {
    MainLevel = MoveUp(MainLevel);    
    MainLevel.Moves++;
   }
   else if (key[KEY_DOWN])
   {
    MainLevel = MoveDown(MainLevel);
    MainLevel.Moves++;
   }
   else if (key[KEY_ESC]) 
   {
    End = 1;
   }
   if(MainLevel.Stage[0][0][1] == 'L' || MainLevel.Stage[0][0][1] == 'W') 
     End = 1;
   PrintLevel(MainLevel);
   clear_keybuf();
  }
 }
 
 if(MainLevel.Stage[0][0][1] == 'L')
 {
  printf("Poor Pid Perishes!");
  MainLevel.Moves = 0;
 }
 else if(MainLevel.Stage[0][0][1] == 'W')
 {
  printf("You got it!");
 }
 else
 {
  printf("Wanna try again...?");
  MainLevel.Moves = 0;
 }
 clear_keybuf();
 readkey();
 clear_keybuf();
 
 return MainLevel.Moves;
}

Player EnterPlayer()
{
 char* File = "111";
 int i = 0;
 printf("\n");
 PrintInitials();
 Name();
 printf("%s", File);
 
 while(i < 3)
 {
  Name();	
  if(keypressed())
  {		
   File[i] = readkey() & 0xff;

   if(File[i] < 48 || (File[i] > 57 && File[i] < 65) || (File[i] > 90 && File[i] < 97) || File[i] > 122)
   {
    File[i] = '1';
    clear_keybuf();
    i = 3;
   }  
   else
   {
    i++;
    clear_keybuf();
   }
   
   printf("  %s", File);
  }
 }
 readkey();
 ClearMyScreen();
 
 Player thePlayer = LoadPlayer(File);
 if(thePlayer.name[i]);
 
 return thePlayer;
}

void PrintMenu(LevelList theList, Player thePlayer)
{	
 Level theLevel = getLevel(theList);
 char* Name = theLevel.name;
 int WID, LID; 
 //at the moment... 
 WID = 1;
 LID = theLevel.ID;
 int Gems = theLevel.NumberOfGems;
 
 char* PlayerName = thePlayer.name;
 int FinishLevel = FindLevel(thePlayer, theLevel.ID);
 int FoundGems = CountFound(thePlayer, theList);
 int TotalGems = theList.TotalGems;
 Variables(Name, WID, LID, Gems, PlayerName, FinishLevel, FoundGems, TotalGems);
}

int MenuSystem()
{
 LevelList theList = CreateLevels();
 Player thePlayer = EnterPlayer();
 
 PrintSelection();
 PrintMenu(theList, thePlayer);	 
 int Moves = 0;
 int Running = 1;
 while(Running)
 {  
  switch(readkey() >> 8) {
        case KEY_LEFT :
        	theList = prevLevel(theList);
                break;
        case KEY_RIGHT :
                theList = nextLevel(theList);
                break;
        case KEY_ESC :
        	Running = 0;
        	break;
        case KEY_ENTER:
                ClearMyScreen();
                Moves = Setup(getLevel(theList));
                ClearMyScreen();
                PrintSelection();
                break;
        default :
                Running = 1;
                break;
  }
  
  if(Moves > 0) thePlayer = EnterData(getLevel(theList).ID, Moves, thePlayer);
  Moves = 0;
  
  PrintMenu(theList, thePlayer);
 }
 freelist(thePlayer);
 return 1;
}

int main (int argc, char *argv[])
{
 init();	
 EraseCursor();
 ClearMyScreen();
 TitleScreen();
 readkey();
 ClearMyScreen();
 MenuSystem();
 ClearMyScreen();
 EndScreen();
 Normalize();
 shutdown();
 return 0;			
}
END_OF_MAIN()
