/*
Gem Slider [Alpha 0.4]
Michael Vendittelli 
Copyright 2003
*/

#include <stdio.h>
#include <stdlib.h>
#include "colour.h"
#include "paint.h"


void Check(char Unit)
{
/*
0 - Ground.
1 - Wall.
S - Main Character.
H or nothing - The level is surrounded by holes automatically.  H defines holes specifically in the level.
E - Enemy.
G - Gems.
T - traps.
B - Blocks/Helpers.
X - Closed Exit.
Y - Open Exit.
*/	
 						//If we find a glitch, just return a Hole.
 if( Unit == '0')			//We check to see what Unit is and return the appropriate graphic.
  ChangeColour(' ', FG_Gray);	
 else if( Unit == '1') 
  ChangeColour(219, FG_Gray|Bright);
 else if( Unit == 'S')
  ChangeColour(2, FG_Brown|Bright);
 else if( Unit == 'H')
  ChangeColour(176, FG_Brown);
 else if( Unit == 'E')
  ChangeColour(157, FG_Red|Bright);
 else if( Unit == 'G')
  ChangeColour(4, FG_Green|Bright);
 else if( Unit == 'T')
  ChangeColour(15, FG_Cyan);
 else if( Unit == 'B')
  ChangeColour(12, FG_Magenta|Bright);
 else if( Unit == 'X')
  ChangeColour('X', FG_Blue);
 else if( Unit == 'Y')
  ChangeColour(240, FG_Blue|Bright);
 else ChangeColour(178, FG_Brown);
}

void PrintLevel(Level theLevel)
{
 int i, j;
 reset();		// set cursor position.
 for ( i = 0; i < 24;  i++ )
   {		//i represents column, j represents row.  It will go through every position and run a Check.
      for ( j = 0; j < 25; j++ )
        {        
         Check(theLevel.Stage[i][j][0]); 
        }
        if(i == 0) printf("          %s", theLevel.name);  // Prints the name of the level if anyone cares.
        if(i == 1) printf("          Gems Left: %d", theLevel.NumberOfGems);  //Prints the number of gems left to collect.
	if(i == 2) printf("          Stage: 1-%d", theLevel.ID);
        if(i == 3) printf("          Moves: %d", theLevel.Moves);
        printf("\n");		//Since the name has a \n...in order to avoid an extra space, we do one or the other.
   }	
}

