#include <stdio.h>
#include <dos.h>
#include "colour.h"
#include <conio.h>

void Name()
{
 gotoxy(35,13);
}

void EraseCursor()
{
 union REGS inregs,outregs;

 inregs.h.ah = 1;                  /* set cursor size */
 inregs.h.ch = 0x20;      /* set bit turns cursor off */
 int86(0x10,&inregs,&outregs);
}

void Normalize()
{
 union REGS inregs,outregs;
	
 inregs.h.ah = 1;                  /* set cursor size */
 inregs.h.ch = 6;                /* cursor start line */
 inregs.h.cl = 7;                  /* cursor end line */
 int86(0x10,&inregs,&outregs);
}
 
void ChangeColour(char ch,unsigned char color)
{
    union REGS regs;
    int x,y;
 
/* First, read the cursor */
 
    regs.h.ah = 0x03;       //Read cursor
    regs.h.bh = 0x00;       //"page"
    int86(VIDEO,&regs,&regs);
    y = regs.h.dl;          //save Y pos.
    x = regs.h.dh;          //save X pos.
 
/* Now, write the color char */
 
    regs.h.ah = 0x09;       //Write color
    regs.h.al = ch;         //character
    regs.h.bh = 0x00;       //"page"
    regs.h.bl = color;      //color
    regs.x.cx = 1;          //count
    int86(VIDEO,&regs,&regs);
 
/* Move the cursor forward one notch */
 
    y++;
 
/* Reset the cursor's position (locate()) */
 
    regs.h.ah=0x02;         //Move cursor
    regs.h.bh=0x00;         //"page"
    regs.h.dh=x;            //row
    regs.h.dl=y;            //column
    int86(VIDEO,&regs,&regs);
}

void reset()
{
 union REGS regs;
 
    regs.h.ah=0x02;         //Move cursor
    regs.h.bh=0x00;         //"page"
    regs.h.dh=0;            //row
    regs.h.dl=0;            //column
    int86(VIDEO,&regs,&regs);
}

void ClearMyScreen() 
{
 clrscr();
}

void TitleScreen()
{
 FILE* Title = fopen("title.scr","r");		
 
 char nextCh = fgetc(Title);
 unsigned char Color = (FG_Gray|Bright);
 
 while(nextCh != EOF)
 {
  if(nextCh == '1') Color = (FG_Red|Bright);
  else if(nextCh == '2') Color = (FG_Green|Bright);
  else if(nextCh == '3') Color = (FG_Blue|Bright);
  else if(nextCh == '4') Color = (FG_Magenta|Bright); 
  else if(nextCh == '5') Color = (FG_Brown|Bright);
  else if(nextCh == '6') printf("\n");
  else if(nextCh == '\n') printf(" ");
  else
    ChangeColour(nextCh, Color);
    
  nextCh = fgetc(Title);
 }	
 fclose(Title);
}

void PrintInitials()
{
  FILE* Init = fopen("penguin.scr","r");		
 
 char nextCh = fgetc(Init);
 unsigned char Color = (FG_Gray|Bright);
 
 while(nextCh != EOF)
 {
  if(nextCh == '1') Color = (FG_Gray|BG_Blue);
  else if(nextCh == '2') Color = (FG_Gray|Bright|BG_Red);
  else if(nextCh == '4') Color = (FG_Green|Bright|BG_Blue); 
  else if(nextCh == '5') Color = (FG_Brown|Bright|BG_Blue);
  else if(nextCh == '6') printf("\n");
  else if(nextCh == '\n') printf(" ");
  else
    ChangeColour(nextCh, Color);
    
  nextCh = fgetc(Init);
 }	
 fclose(Init);	
}

void PrintSelection()
{
 FILE* Menu = fopen("choose.scr","r");		
 
 int nextCh = fgetc(Menu);
 unsigned char Color = (FG_Gray|BG_Blue);
 
 while(nextCh != EOF)
 {
  if(nextCh == 234)
  {
   printf("\n");
  }
  else if(nextCh == 191 || nextCh == 217) 
  {
   ChangeColour(nextCh, Color);
   Color = (FG_Gray|BG_Blue);	
  }
  else if(nextCh < 32);
  else
  {
   if(nextCh == 176) Color = (FG_Gray|BG_Blue);
   else if(nextCh > 178) Color = (FG_Gray|Bright|BG_Red); 

   ChangeColour(nextCh, Color);
  }
    
  nextCh = fgetc(Menu);
 }	
 fclose(Menu);
 //Done printing menu.
}

void Variables(char* LevelName, int WID, int LID, int Gems, char* PlayerName, int FinishLevel, int FoundGems, int TotalGems)
{
 gotoxy(52,10);
 printf("                         ");
 gotoxy(52,10);
 printf("%s", LevelName);
 
 gotoxy(59,11);
 printf("       ");
 gotoxy(59,11);
 printf("%d-%d", WID, LID);

 gotoxy(63,12);
 printf("     ");
 gotoxy(63,12);
 printf("%d", Gems); 
 
 gotoxy(17,10);
 printf("    ");
 gotoxy(17,10);
 printf("%c%c%c", PlayerName[0], PlayerName[1], PlayerName[2]);
  
 gotoxy(20,11);
 printf("     ");
 gotoxy(20,11);
 if(FinishLevel > 0)
 {
  printf("Yes"); 
 }
 else
 {
  printf("No");	
 } 

 gotoxy(19,12);
 printf("    ");
 gotoxy(19,12);
 printf("%d", FinishLevel);
 
 gotoxy(21,14);
 printf("    ");
 gotoxy(15,14);
 printf("%d / %d", FoundGems, TotalGems);
 
 reset();
}

void EndScreen()
{
 FILE* End = fopen("end.scr","r");
 
 char nextCh = fgetc(End);	
 unsigned char Color = (FG_Gray|Bright);
 
 while(nextCh != EOF)
 {
  if(nextCh == '2') Color = (FG_Gray|Bright|BG_Blue);
  else if(nextCh == '3') Color = (FG_Gray|BG_Black);
  else if(nextCh == '4') Color = (FG_Black|BG_Green);
  else if(nextCh == '5') Color = (FG_Brown|Bright|BG_Cyan); 
  else if(nextCh == '6') printf("\n");
  else if(nextCh == '\n') printf(" ");
  else
    ChangeColour(nextCh, Color);
    
  nextCh = fgetc(End);
 }	
 fclose(End);
}
