#include <stdio.h>
#include <dos.h>
#include <ctype.h>

/*
  Hey there, you'll notice that I did not use the conio library to change and use colours.  This was because I was
unaware of that particular library until recently.  Still, I prefer handling the colours myself still, it helps people
understand what's going on.  First let me explain how this is used:

In order to change anything, we have to modify Page 0.  That is the Page that is currently on screen.  If I modify Page
1 first and then set Page 0 = Page 1; it would do an instant redraw with absolutely no delays.

I did not do this.

Rather, I make changes to Page 0 on the fly.  This may not be the optimal way of doing it, so maybe I'll rewrite it later.
As for right now, all of the hex you see below are the particular values of each thing you can do to the Pages (the
screen is Page 0, remember).

You may notice some American spellings, (color->colour).  That is because I'm one sloppy Canadian.  I should probably
clean that up too...come to think of it.
*/
 
#define VIDEO 0x10		// Page 0.

#define FG_Black 0x00
#define FG_Blue 0x01
#define FG_Green 0x02
#define FG_Cyan 0x03
#define FG_Red 0x04
#define FG_Magenta 0x05
#define FG_Brown 0x06		// This will change what the prompt writes in terms of colours.  The FGs represent fore-
#define FG_Gray 0x07		// ground colours.  You'll notice that only 8 are listed, but there should be a total
#define BG_Black 0x00		// of sixteen foreground colours (if you know prompt writing at all).  In order to get
#define BG_Blue 0x10		// The brighter ones, you must pipe it into an unsigned character.  BG_Red|Bright will
#define BG_Green 0x20		// make it bright red, not dark red.  BG_Red|Bright|Blinking will make the text blink
#define BG_Cyan 0x30		// as well.  Add |BG_Cyan to change the background colour.  No, you may not make the
#define BG_Red 0x40		// BGs bright, so you are limited in that particular way.
#define BG_Magenta 0x50
#define BG_Brown 0x60
#define BG_Gray 0x70
#define Bright 0x08
#define Blinking 0x80

void ChangeColour(char ch,unsigned char color);

/*
Pre:  Takes in the character to print to the current cursor position and a pipeline of colour changes.
Post:  Prints the character using colours specified.
*/

void Name();

/*
When the user enters their name, we have to print the initials to the screen between the two penguins.
This just resets the cursor position there as a helper function.
*/

void PrintInitials();

/*
Okay, this is one of four screens.  You'll notice that penguin.scr, title.scr, and end.scr  use numbers to change
to particular colors.  choose.scr has a more sophisticated function (because I actually need to display numbers there;
perhaps I'll end up making them all that sophisticated, but I can't think of an algorithm to pull it off) where it
detects borderlines and shadows.  This is one of the three that uses numbers and converts them to colour codes.
It prints penguin.scr to the screen and is used in conjunction with Name() to re-align the cursor.
*/

void PrintSelection();

/*
Here is the sophisticated function that prints choose.scr using higher-ascii detection.  It prints the in-game menu
where you select levels.  It does not print the variables (such as current level and player information), because we
do not wish to redraw the whole screen...just those particular areas.  We use Variables(....) in conjunction with
this one to display all menu information.
*/

void Variables(char* LevelName, int WID, int LID, int Gems, char* PlayerName, int FinishLevel, int FoundGems, int TotalGems);

/*
Wow...this function prints all variables to the Menu screen.  This includes Name of Level selected at the moment,
it's World ID - Level ID (think Mario 1 here),  and the number of gems it contains.  Let's not forget the Player.
It takes their name and how many levels they've finished.  I will change this to total Gems collected because
that is more meaningful.
*/

void reset();
void ClearMyScreen();
void EraseCursor();
void Normalize();
void TitleScreen();
void EndScreen();

