#include "lvllist.h"

void freeLevels(LevelList theList) 
{
 theList.Current = theList.Head;

 while (theList.Current != NULL) 
 { 	 
  theList.Current = theList.Head->next;
  free(theList.Head);
  theList.Head = theList.Current;
 }
}

LevelList addLevel(LevelList theList, Level nextLevel)
{
 LvlNode* newNode = malloc(4000);
 
 theList.TotalGems += nextLevel.NumberOfGems;
 
 newNode->theLevel = nextLevel;
 newNode->next = newNode->prev = NULL; 
 	
 if (theList.Head == NULL)
 {
  theList.Head = newNode;
  theList.Current = theList.Head;
  theList.Tail = theList.Current;
  theList.Head->next = NULL;
  theList.Head->prev = NULL;
 }

 else
 {
  theList.Current = theList.Head;  
  while(theList.Current->next != NULL && (newNode->theLevel.ID > theList.Current->theLevel.ID))
   theList.Current = theList.Current->next;

  
  if(newNode->theLevel.ID <= theList.Current->theLevel.ID)
  {
   newNode->next = theList.Current;
   newNode->prev = theList.Current->prev;
   theList.Current->prev = newNode;

   if(newNode->prev == NULL)
   {
     theList.Head = newNode;
   }
   else
     newNode->prev->next = newNode;	
  }
  else
  {
   newNode->prev = theList.Current;
   newNode->next = theList.Current->next;
   theList.Current->next = newNode;
   if(newNode->next == NULL)
   {
     theList.Tail = newNode;
   }
   else
    newNode->next->prev = newNode;
  }
  
  while(theList.Head->prev != NULL)  theList.Head = theList.Head->prev;
  while(theList.Tail->next != NULL)  theList.Tail = theList.Tail->next;
 }
 return theList;
}

LevelList CreateLevels()
{
 system("dir /b levels\\*.dat > levels.lst");
 char* NextLevel = "levels/testtest.tst";	// MUST be 8 characters . 3 characters.
 FILE* List = fopen("levels.lst", "r");
 int c;
 LevelList theList;
 theList.TotalGems = 0;
 theList.Head = NULL;
 theList.Current = NULL;
 
 while( (c = fscanf(List, "%s", NextLevel)) != EOF)
 {
   theList = addLevel( theList, Create(NextLevel));
 } 

 theList.Current = theList.Head;
 
 return theList;
}

Level getLevel(LevelList theList)
{
 while(theList.Current == NULL)
 {
  theList = nextLevel(theList);
 }
 	
 return theList.Current->theLevel;	
}

LevelList nextLevel(LevelList theList)
{
 theList.Current = theList.Current->next;
 if(theList.Current == NULL)
 {
  theList.Current = theList.Head;	
 }
 return theList;	
}

LevelList prevLevel(LevelList theList)
{ 
 theList.Current = theList.Current->prev;
 if(theList.Current == NULL)
 {
  theList.Current = theList.Tail;	
 }
 return theList;
}
